local oldUnit = Unit

Unit = Class(oldUnit) {
	
	UnitsBuildingMe = {},
	GroupBuildPenalty = 0,

    UpdateConsumptionValues = function(self)
		oldUnit.UpdateConsumptionValues(self)
		
		local buildtime = 1 / self:GetBuildRate()
		buildtime = buildtime * self.GroupBuildPenalty
		
		self:SetBuildRate(1 / buildtime)
    end,

    OnStartBuild = function(self, unitBeingBuilt, order)
		oldUnit.OnStartBuild(self, unitBeingBuilt, order)
		
		if self::GetBlueprint().Economy.BuildRate ~= 0 then
			self.GroupBuildPenalty = 0
			unitBeingBuilt:AddToBuildingMeList(self)	
		end	
    end,
	
	AddToBuildingMeList = function(self, builder)
		table.insert(self.UnitsBuildingMe, builder)

		self:UpdateGroupBuildPenalites()
	end,
	
	RemoveFromBuildingMeList = function(self, builder)
		for k,v in self.UnitsBuildingMe do
			if v == builder then 
				table.remove(self.UnitsBuildingMe, k)
				break
			end
		end
		
		self:UpdateGroupBuildPenalites()
	end,
	
	UpdateGroupBuildPenalites = function(self)
		local count = table.getn(self.UnitsBuildingMe)
		local penalty = 1 + math.max((count - 1) * 0.05, 0)
				
		if(count > 1) then
			for k,v in self.UnitsBuildingMe do
				v.GroupBuildPenalty = penalty
				v:UpdateConsumptionValues()
			end		
		end
	end,

    OnStopBuild = function(self, unitBeingBuilt)
		oldUnit.OnStopBuild(self, unitBeingBuilt)
		
		if self::GetBlueprint().Economy.BuildRate ~= 0 then
			self.GroupBuildPenalty = 0
			unitBeingBuilt:RemoveFromBuildingMeList(self)
		end
    end,
}

